diff -Naur ruby-1.9.3-p547.original/vm.inc ruby-1.9.3-p547.htm/vm.inc
--- ruby-1.9.3-p547.original/vm.inc	2014-05-16 23:38:33.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm.inc	2014-09-12 06:37:35.905002000 +0900
@@ -25,7 +25,7 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(nop));
 {
-#line 40 "insns.def"
+#line 41 "insns.def"
     /* none */
 
 #line 32 "vm.inc"
@@ -40,6 +40,9 @@
   lindex_t idx = (lindex_t)GET_OPERAND(1);
 
   DEBUG_ENTER_INSN("getlocal");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+1);
   PREFETCH(GET_PC());
   #define CURRENT_INSN_getlocal 1
@@ -49,10 +52,10 @@
   USAGE_ANALYSIS_INSN(BIN(getlocal));
   USAGE_ANALYSIS_OPERAND(BIN(getlocal), 0, idx);
 {
-#line 58 "insns.def"
+#line 59 "insns.def"
     val = *(GET_LFP() - idx);
 
-#line 56 "vm.inc"
+#line 59 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getlocal
@@ -75,10 +78,10 @@
   USAGE_ANALYSIS_INSN(BIN(setlocal));
   USAGE_ANALYSIS_OPERAND(BIN(setlocal), 0, idx);
 {
-#line 72 "insns.def"
+#line 73 "insns.def"
     (*(GET_LFP() - idx)) = val;
 
-#line 82 "vm.inc"
+#line 85 "vm.inc"
 #undef CURRENT_INSN_setlocal
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -101,10 +104,10 @@
   USAGE_ANALYSIS_OPERAND(BIN(getspecial), 0, key);
   USAGE_ANALYSIS_OPERAND(BIN(getspecial), 1, type);
 {
-#line 86 "insns.def"
+#line 87 "insns.def"
     val = vm_getspecial(th, GET_LFP(), key, type);
 
-#line 108 "vm.inc"
+#line 111 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getspecial
@@ -127,10 +130,10 @@
   USAGE_ANALYSIS_INSN(BIN(setspecial));
   USAGE_ANALYSIS_OPERAND(BIN(setspecial), 0, key);
 {
-#line 100 "insns.def"
+#line 101 "insns.def"
     lfp_svar_set(th, GET_LFP(), key, obj);
 
-#line 134 "vm.inc"
+#line 137 "vm.inc"
 #undef CURRENT_INSN_setspecial
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -153,7 +156,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(getdynamic), 0, idx);
   USAGE_ANALYSIS_OPERAND(BIN(getdynamic), 1, level);
 {
-#line 116 "insns.def"
+#line 117 "insns.def"
     rb_num_t i;
     VALUE *dfp2 = GET_DFP();
     for (i = 0; i < level; i++) {
@@ -161,7 +164,7 @@
     }
     val = *(dfp2 - idx);
 
-#line 165 "vm.inc"
+#line 168 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getdynamic
@@ -186,7 +189,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(setdynamic), 0, idx);
   USAGE_ANALYSIS_OPERAND(BIN(setdynamic), 1, level);
 {
-#line 137 "insns.def"
+#line 138 "insns.def"
     rb_num_t i;
     VALUE *dfp2 = GET_DFP();
     for (i = 0; i < level; i++) {
@@ -194,7 +197,7 @@
     }
     *(dfp2 - idx) = val;
 
-#line 198 "vm.inc"
+#line 201 "vm.inc"
 #undef CURRENT_INSN_setdynamic
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -207,6 +210,9 @@
   ID id = (ID)GET_OPERAND(1);
 
   DEBUG_ENTER_INSN("getinstancevariable");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+2);
   PREFETCH(GET_PC());
   #define CURRENT_INSN_getinstancevariable 1
@@ -217,10 +223,10 @@
   USAGE_ANALYSIS_OPERAND(BIN(getinstancevariable), 0, id);
   USAGE_ANALYSIS_OPERAND(BIN(getinstancevariable), 1, ic);
 {
-#line 157 "insns.def"
+#line 158 "insns.def"
     val = vm_getivar(GET_SELF(), id, ic);
 
-#line 224 "vm.inc"
+#line 230 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getinstancevariable
@@ -245,10 +251,10 @@
   USAGE_ANALYSIS_OPERAND(BIN(setinstancevariable), 0, id);
   USAGE_ANALYSIS_OPERAND(BIN(setinstancevariable), 1, ic);
 {
-#line 172 "insns.def"
+#line 173 "insns.def"
     vm_setivar(GET_SELF(), id, val, ic);
 
-#line 252 "vm.inc"
+#line 258 "vm.inc"
 #undef CURRENT_INSN_setinstancevariable
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -260,6 +266,9 @@
   ID id = (ID)GET_OPERAND(1);
 
   DEBUG_ENTER_INSN("getclassvariable");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+1);
   PREFETCH(GET_PC());
   #define CURRENT_INSN_getclassvariable 1
@@ -269,11 +278,11 @@
   USAGE_ANALYSIS_INSN(BIN(getclassvariable));
   USAGE_ANALYSIS_OPERAND(BIN(getclassvariable), 0, id);
 {
-#line 186 "insns.def"
+#line 187 "insns.def"
     NODE * const cref = vm_get_cref(GET_ISEQ(), GET_LFP(), GET_DFP());
     val = rb_cvar_get(vm_get_cvar_base(cref), id);
 
-#line 277 "vm.inc"
+#line 286 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getclassvariable
@@ -296,11 +305,11 @@
   USAGE_ANALYSIS_INSN(BIN(setclassvariable));
   USAGE_ANALYSIS_OPERAND(BIN(setclassvariable), 0, id);
 {
-#line 201 "insns.def"
+#line 202 "insns.def"
     NODE * const cref = vm_get_cref(GET_ISEQ(), GET_LFP(), GET_DFP());
     rb_cvar_set(vm_get_cvar_base(cref), id, val);
 
-#line 304 "vm.inc"
+#line 313 "vm.inc"
 #undef CURRENT_INSN_setclassvariable
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -322,10 +331,10 @@
   USAGE_ANALYSIS_INSN(BIN(getconstant));
   USAGE_ANALYSIS_OPERAND(BIN(getconstant), 0, id);
 {
-#line 223 "insns.def"
+#line 224 "insns.def"
     val = vm_get_ev_const(th, GET_ISEQ(), klass, id, 0);
 
-#line 329 "vm.inc"
+#line 338 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getconstant
@@ -349,12 +358,12 @@
   USAGE_ANALYSIS_INSN(BIN(setconstant));
   USAGE_ANALYSIS_OPERAND(BIN(setconstant), 0, id);
 {
-#line 245 "insns.def"
+#line 246 "insns.def"
     vm_check_if_namespace(cbase);
     rb_const_set(cbase, id, val);
     INC_VM_STATE_VERSION();
 
-#line 358 "vm.inc"
+#line 367 "vm.inc"
 #undef CURRENT_INSN_setconstant
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -375,10 +384,10 @@
   USAGE_ANALYSIS_INSN(BIN(getglobal));
   USAGE_ANALYSIS_OPERAND(BIN(getglobal), 0, entry);
 {
-#line 261 "insns.def"
+#line 262 "insns.def"
     val = GET_GLOBAL((VALUE)entry);
 
-#line 382 "vm.inc"
+#line 391 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getglobal
@@ -401,10 +410,10 @@
   USAGE_ANALYSIS_INSN(BIN(setglobal));
   USAGE_ANALYSIS_OPERAND(BIN(setglobal), 0, entry);
 {
-#line 275 "insns.def"
+#line 276 "insns.def"
     SET_GLOBAL((VALUE)entry, val);
 
-#line 408 "vm.inc"
+#line 417 "vm.inc"
 #undef CURRENT_INSN_setglobal
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -424,10 +433,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(putnil));
 {
-#line 294 "insns.def"
+#line 295 "insns.def"
     val = Qnil;
 
-#line 431 "vm.inc"
+#line 440 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_putnil
@@ -449,10 +458,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(putself));
 {
-#line 308 "insns.def"
+#line 309 "insns.def"
     val = GET_SELF();
 
-#line 456 "vm.inc"
+#line 465 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_putself
@@ -474,10 +483,10 @@
   USAGE_ANALYSIS_INSN(BIN(putobject));
   USAGE_ANALYSIS_OPERAND(BIN(putobject), 0, val);
 {
-#line 324 "insns.def"
+#line 325 "insns.def"
     /* */
 
-#line 481 "vm.inc"
+#line 490 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_putobject
@@ -500,7 +509,7 @@
   USAGE_ANALYSIS_INSN(BIN(putspecialobject));
   USAGE_ANALYSIS_OPERAND(BIN(putspecialobject), 0, value_type);
 {
-#line 339 "insns.def"
+#line 340 "insns.def"
     enum vm_special_object_type type = (enum vm_special_object_type)value_type;
 
     switch (type) {
@@ -517,7 +526,7 @@
 	rb_bug("putspecialobject insn: unknown value_type");
     }
 
-#line 521 "vm.inc"
+#line 530 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_putspecialobject
@@ -540,10 +549,10 @@
   USAGE_ANALYSIS_INSN(BIN(putiseq));
   USAGE_ANALYSIS_OPERAND(BIN(putiseq), 0, iseq);
 {
-#line 367 "insns.def"
+#line 368 "insns.def"
     ret = iseq->self;
 
-#line 547 "vm.inc"
+#line 556 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(ret);
 #undef CURRENT_INSN_putiseq
@@ -566,10 +575,10 @@
   USAGE_ANALYSIS_INSN(BIN(putstring));
   USAGE_ANALYSIS_OPERAND(BIN(putstring), 0, str);
 {
-#line 381 "insns.def"
+#line 382 "insns.def"
     val = rb_str_resurrect(str);
 
-#line 573 "vm.inc"
+#line 582 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_putstring
@@ -592,7 +601,7 @@
   USAGE_ANALYSIS_INSN(BIN(concatstrings));
   USAGE_ANALYSIS_OPERAND(BIN(concatstrings), 0, num);
 {
-#line 395 "insns.def"
+#line 396 "insns.def"
     rb_num_t i = num - 1;
 
     val = rb_str_resurrect(TOPN(i));
@@ -602,7 +611,7 @@
     }
     POPN(num);
 
-#line 606 "vm.inc"
+#line 615 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_concatstrings
@@ -624,10 +633,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(tostring));
 {
-#line 416 "insns.def"
+#line 417 "insns.def"
     val = rb_obj_as_string(val);
 
-#line 631 "vm.inc"
+#line 640 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_tostring
@@ -652,7 +661,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(toregexp), 0, opt);
   USAGE_ANALYSIS_OPERAND(BIN(toregexp), 1, cnt);
 {
-#line 431 "insns.def"
+#line 432 "insns.def"
     VALUE rb_reg_new_ary(VALUE ary, int options);
     rb_num_t i;
     const VALUE ary = rb_ary_tmp_new(cnt);
@@ -663,7 +672,7 @@
     val = rb_reg_new_ary(ary, (int)opt);
     rb_ary_clear(ary);
 
-#line 667 "vm.inc"
+#line 676 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_toregexp
@@ -686,11 +695,11 @@
   USAGE_ANALYSIS_INSN(BIN(newarray));
   USAGE_ANALYSIS_OPERAND(BIN(newarray), 0, num);
 {
-#line 453 "insns.def"
+#line 454 "insns.def"
     val = rb_ary_new4((long)num, STACK_ADDR_FROM_TOP(num));
     POPN(num);
 
-#line 694 "vm.inc"
+#line 703 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_newarray
@@ -713,10 +722,10 @@
   USAGE_ANALYSIS_INSN(BIN(duparray));
   USAGE_ANALYSIS_OPERAND(BIN(duparray), 0, ary);
 {
-#line 468 "insns.def"
+#line 469 "insns.def"
     val = rb_ary_resurrect(ary);
 
-#line 720 "vm.inc"
+#line 729 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_duparray
@@ -741,10 +750,10 @@
   USAGE_ANALYSIS_OPERAND(BIN(expandarray), 0, num);
   USAGE_ANALYSIS_OPERAND(BIN(expandarray), 1, flag);
 {
-#line 489 "insns.def"
+#line 490 "insns.def"
     vm_expandarray(GET_CFP(), ary, num, (int)flag);
 
-#line 748 "vm.inc"
+#line 757 "vm.inc"
 #undef CURRENT_INSN_expandarray
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -766,7 +775,7 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(concatarray));
 {
-#line 503 "insns.def"
+#line 504 "insns.def"
     const VALUE ary2 = ary2st;
     VALUE tmp1 = rb_check_convert_type(ary1, T_ARRAY, "Array", "to_a");
     VALUE tmp2 = rb_check_convert_type(ary2, T_ARRAY, "Array", "to_a");
@@ -784,7 +793,7 @@
     }
     ary = rb_ary_concat(tmp1, tmp2);
 
-#line 788 "vm.inc"
+#line 797 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(ary);
 #undef CURRENT_INSN_concatarray
@@ -808,7 +817,7 @@
   USAGE_ANALYSIS_INSN(BIN(splatarray));
   USAGE_ANALYSIS_OPERAND(BIN(splatarray), 0, flag);
 {
-#line 532 "insns.def"
+#line 533 "insns.def"
     VALUE tmp = rb_check_convert_type(ary, T_ARRAY, "Array", "to_a");
     if (NIL_P(tmp)) {
 	tmp = rb_ary_new3(1, ary);
@@ -818,7 +827,7 @@
     }
     obj = tmp;
 
-#line 822 "vm.inc"
+#line 831 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(obj);
 #undef CURRENT_INSN_splatarray
@@ -843,7 +852,7 @@
   USAGE_ANALYSIS_INSN(BIN(checkincludearray));
   USAGE_ANALYSIS_OPERAND(BIN(checkincludearray), 0, flag);
 {
-#line 553 "insns.def"
+#line 554 "insns.def"
     int i;
     result = Qfalse;
 
@@ -872,7 +881,7 @@
 	}
     }
 
-#line 876 "vm.inc"
+#line 885 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 2);
   PUSH(obj);
   PUSH(result);
@@ -896,7 +905,7 @@
   USAGE_ANALYSIS_INSN(BIN(newhash));
   USAGE_ANALYSIS_OPERAND(BIN(newhash), 0, num);
 {
-#line 594 "insns.def"
+#line 595 "insns.def"
     rb_num_t i;
     val = rb_hash_new();
 
@@ -907,7 +916,7 @@
     }
     POPN(num);
 
-#line 911 "vm.inc"
+#line 920 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_newhash
@@ -932,10 +941,10 @@
   USAGE_ANALYSIS_INSN(BIN(newrange));
   USAGE_ANALYSIS_OPERAND(BIN(newrange), 0, flag);
 {
-#line 616 "insns.def"
+#line 617 "insns.def"
     val = rb_range_new(low, high, (int)flag);
 
-#line 939 "vm.inc"
+#line 948 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_newrange
@@ -957,11 +966,11 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(pop));
 {
-#line 634 "insns.def"
+#line 635 "insns.def"
     (void)val;
     /* none */
 
-#line 965 "vm.inc"
+#line 974 "vm.inc"
 #undef CURRENT_INSN_pop
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -983,10 +992,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(dup));
 {
-#line 649 "insns.def"
+#line 650 "insns.def"
     val1 = val2 = val;
 
-#line 990 "vm.inc"
+#line 999 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 2);
   PUSH(val1);
   PUSH(val2);
@@ -1009,7 +1018,7 @@
   USAGE_ANALYSIS_INSN(BIN(dupn));
   USAGE_ANALYSIS_OPERAND(BIN(dupn), 0, n);
 {
-#line 663 "insns.def"
+#line 664 "insns.def"
     rb_num_t i;
     VALUE *sp = STACK_ADDR_FROM_TOP(n);
     for (i = 0; i < n; i++) {
@@ -1017,7 +1026,7 @@
     }
     INC_SP(n);
 
-#line 1021 "vm.inc"
+#line 1030 "vm.inc"
 #undef CURRENT_INSN_dupn
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1038,10 +1047,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(swap));
 {
-#line 683 "insns.def"
+#line 684 "insns.def"
     /* none */
 
-#line 1045 "vm.inc"
+#line 1054 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 2);
   PUSH(obj);
   PUSH(val);
@@ -1064,10 +1073,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(reput));
 {
-#line 697 "insns.def"
+#line 698 "insns.def"
     /* none */
 
-#line 1071 "vm.inc"
+#line 1080 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_reput
@@ -1090,10 +1099,10 @@
   USAGE_ANALYSIS_INSN(BIN(topn));
   USAGE_ANALYSIS_OPERAND(BIN(topn), 0, n);
 {
-#line 711 "insns.def"
+#line 712 "insns.def"
     val = TOPN(n);
 
-#line 1097 "vm.inc"
+#line 1106 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_topn
@@ -1116,10 +1125,10 @@
   USAGE_ANALYSIS_INSN(BIN(setn));
   USAGE_ANALYSIS_OPERAND(BIN(setn), 0, n);
 {
-#line 725 "insns.def"
+#line 726 "insns.def"
     TOPN(n-1) = val;
 
-#line 1123 "vm.inc"
+#line 1132 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_setn
@@ -1141,10 +1150,10 @@
   USAGE_ANALYSIS_INSN(BIN(adjuststack));
   USAGE_ANALYSIS_OPERAND(BIN(adjuststack), 0, n);
 {
-#line 739 "insns.def"
+#line 740 "insns.def"
     DEC_SP(n);
 
-#line 1148 "vm.inc"
+#line 1157 "vm.inc"
 #undef CURRENT_INSN_adjuststack
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1170,7 +1179,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(defined), 1, obj);
   USAGE_ANALYSIS_OPERAND(BIN(defined), 2, needstr);
 {
-#line 758 "insns.def"
+#line 759 "insns.def"
     VALUE klass;
     const char *expr_type = 0;
     enum defined_type type = (enum defined_type)op_type;
@@ -1277,7 +1286,7 @@
 	}
     }
 
-#line 1281 "vm.inc"
+#line 1290 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_defined
@@ -1299,12 +1308,12 @@
   USAGE_ANALYSIS_INSN(BIN(trace));
   USAGE_ANALYSIS_OPERAND(BIN(trace), 0, nf);
 {
-#line 876 "insns.def"
+#line 877 "insns.def"
     rb_event_flag_t flag = (rb_event_flag_t)nf;
 
     EXEC_EVENT_HOOK(th, flag, GET_SELF(), 0, 0 /* TODO: id, klass */);
 
-#line 1308 "vm.inc"
+#line 1317 "vm.inc"
 #undef CURRENT_INSN_trace
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1331,7 +1340,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(defineclass), 1, class_iseq);
   USAGE_ANALYSIS_OPERAND(BIN(defineclass), 2, define_type);
 {
-#line 900 "insns.def"
+#line 901 "insns.def"
     VALUE klass;
 
     switch ((int)define_type) {
@@ -1415,7 +1424,7 @@
     INC_VM_STATE_VERSION();
     NEXT_INSN();
 
-#line 1419 "vm.inc"
+#line 1428 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_defineclass
@@ -1433,6 +1442,9 @@
   ID op_id = (ID)GET_OPERAND(1);
 
   DEBUG_ENTER_INSN("send");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+5);
   PREFETCH(GET_PC());
   #define CURRENT_INSN_send 1
@@ -1446,7 +1458,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(send), 3, op_flag);
   USAGE_ANALYSIS_OPERAND(BIN(send), 4, ic);
 {
-#line 1006 "insns.def"
+#line 1007 "insns.def"
     const rb_method_entry_t *me;
     VALUE recv, klass;
     rb_block_t *blockptr = 0;
@@ -1461,7 +1473,7 @@
     me = vm_method_search(id, klass, ic);
     CALL_METHOD(num, blockptr, flag, id, me, recv);
 
-#line 1465 "vm.inc"
+#line 1477 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_send
@@ -1488,7 +1500,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(invokesuper), 1, blockiseq);
   USAGE_ANALYSIS_OPERAND(BIN(invokesuper), 2, op_flag);
 {
-#line 1034 "insns.def"
+#line 1035 "insns.def"
     rb_block_t *blockptr = !(op_flag & VM_CALL_ARGS_BLOCKARG_BIT) ? GET_BLOCK_PTR() : 0;
     VALUE flag = op_flag;
     int num = caller_setup_args(th, GET_CFP(), flag,
@@ -1511,7 +1523,7 @@
 
     CALL_METHOD(num, blockptr, flag, id, me, recv);
 
-#line 1515 "vm.inc"
+#line 1527 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_invokesuper
@@ -1536,14 +1548,14 @@
   USAGE_ANALYSIS_OPERAND(BIN(invokeblock), 0, num);
   USAGE_ANALYSIS_OPERAND(BIN(invokeblock), 1, flag);
 {
-#line 1069 "insns.def"
+#line 1070 "insns.def"
     val = vm_invoke_block(th, GET_CFP(), num, flag);
     if (val == Qundef) {
 	RESTORE_REGS();
 	NEXT_INSN();
     }
 
-#line 1547 "vm.inc"
+#line 1559 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_invokeblock
@@ -1565,7 +1577,7 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(leave));
 {
-#line 1087 "insns.def"
+#line 1088 "insns.def"
     if (OPT_CHECKED_RUN) {
 	if (reg_cfp->sp != reg_cfp->bp) {
 	    rb_bug("Stack consistency error (sp: %"PRIdPTRDIFF", bp: %"PRIdPTRDIFF")",
@@ -1573,11 +1585,15 @@
 	}
     }
 
+#ifdef HTM_GVL
+    RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-1));
+#else
     RUBY_VM_CHECK_INTS();
+#endif
     vm_pop_frame(th);
     RESTORE_REGS();
 
-#line 1581 "vm.inc"
+#line 1597 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_leave
@@ -1599,7 +1615,7 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(finish));
 {
-#line 1110 "insns.def"
+#line 1115 "insns.def"
 #if OPT_CALL_THREADED_CODE
     rb_bug("unused instruction on OPT_CALL_THREADED_CODE");
 #else
@@ -1607,7 +1623,7 @@
     return val;
 #endif
 
-#line 1611 "vm.inc"
+#line 1627 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_finish
@@ -1631,13 +1647,17 @@
   USAGE_ANALYSIS_INSN(BIN(throw));
   USAGE_ANALYSIS_OPERAND(BIN(throw), 0, throw_state);
 {
-#line 1133 "insns.def"
+#line 1138 "insns.def"
+#ifdef HTM_GVL
+    RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
     RUBY_VM_CHECK_INTS();
+#endif
     val = vm_throw(th, GET_CFP(), throw_state, throwobj);
     THROW_EXCEPTION(val);
     /* unreachable */
 
-#line 1641 "vm.inc"
+#line 1661 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_throw
@@ -1659,11 +1679,15 @@
   USAGE_ANALYSIS_INSN(BIN(jump));
   USAGE_ANALYSIS_OPERAND(BIN(jump), 0, dst);
 {
-#line 1154 "insns.def"
+#line 1163 "insns.def"
+#ifdef HTM_GVL
+    RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
     RUBY_VM_CHECK_INTS();
+#endif
     JUMP(dst);
 
-#line 1667 "vm.inc"
+#line 1691 "vm.inc"
 #undef CURRENT_INSN_jump
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1684,13 +1708,17 @@
   USAGE_ANALYSIS_INSN(BIN(branchif));
   USAGE_ANALYSIS_OPERAND(BIN(branchif), 0, dst);
 {
-#line 1169 "insns.def"
+#line 1182 "insns.def"
     if (RTEST(val)) {
+#ifdef HTM_GVL
+        RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
 	RUBY_VM_CHECK_INTS();
+#endif
 	JUMP(dst);
     }
 
-#line 1694 "vm.inc"
+#line 1722 "vm.inc"
 #undef CURRENT_INSN_branchif
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1711,13 +1739,17 @@
   USAGE_ANALYSIS_INSN(BIN(branchunless));
   USAGE_ANALYSIS_OPERAND(BIN(branchunless), 0, dst);
 {
-#line 1186 "insns.def"
+#line 1203 "insns.def"
     if (!RTEST(val)) {
+#ifdef HTM_GVL
+        RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-2));
+#else
 	RUBY_VM_CHECK_INTS();
+#endif
 	JUMP(dst);
     }
 
-#line 1721 "vm.inc"
+#line 1753 "vm.inc"
 #undef CURRENT_INSN_branchunless
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1740,7 +1772,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(getinlinecache), 0, dst);
   USAGE_ANALYSIS_OPERAND(BIN(getinlinecache), 1, ic);
 {
-#line 1208 "insns.def"
+#line 1229 "insns.def"
     if (ic->ic_vmstat == GET_VM_STATE_VERSION()) {
 	val = ic->ic_value.value;
 	JUMP(dst);
@@ -1750,7 +1782,7 @@
 	val = Qnil;
     }
 
-#line 1754 "vm.inc"
+#line 1786 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_getinlinecache
@@ -1775,7 +1807,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(onceinlinecache), 0, dst);
   USAGE_ANALYSIS_OPERAND(BIN(onceinlinecache), 1, ic);
 {
-#line 1229 "insns.def"
+#line 1250 "insns.def"
   retry:
     if (ic->ic_vmstat) {
 	val = ic->ic_value.value;
@@ -1783,7 +1815,11 @@
     }
     else if (ic->ic_value.value == Qundef)
     {
-    	RUBY_VM_CHECK_INTS();
+#ifdef HTM_GVL
+        RUBY_VM_CHECK_INTS_EXEC_CORE(&GET_OPERAND(-3));
+#else
+	RUBY_VM_CHECK_INTS();
+#endif
     	rb_thread_schedule();
 	goto retry;
     }
@@ -1793,7 +1829,7 @@
 	val = Qnil;
     }
 
-#line 1797 "vm.inc"
+#line 1833 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_onceinlinecache
@@ -1816,7 +1852,7 @@
   USAGE_ANALYSIS_INSN(BIN(setinlinecache));
   USAGE_ANALYSIS_OPERAND(BIN(setinlinecache), 0, ic);
 {
-#line 1258 "insns.def"
+#line 1283 "insns.def"
     if (ic->ic_value.value == Qundef) {
 	rb_ary_push(GET_ISEQ()->mark_ary, val);
     }
@@ -1824,7 +1860,7 @@
     ic->ic_vmstat = GET_VM_STATE_VERSION() - ruby_vm_const_missing_count;
     ruby_vm_const_missing_count = 0;
 
-#line 1828 "vm.inc"
+#line 1864 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_setinlinecache
@@ -1849,7 +1885,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(opt_case_dispatch), 0, hash);
   USAGE_ANALYSIS_OPERAND(BIN(opt_case_dispatch), 1, else_offset);
 {
-#line 1277 "insns.def"
+#line 1302 "insns.def"
     switch(TYPE(key)) {
       case T_FLOAT: {
 	double ival;
@@ -1875,7 +1911,7 @@
 	break;
     }
 
-#line 1879 "vm.inc"
+#line 1915 "vm.inc"
 #undef CURRENT_INSN_opt_case_dispatch
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1894,7 +1930,7 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(opt_checkenv));
 {
-#line 1314 "insns.def"
+#line 1339 "insns.def"
     if (GET_CFP()->bp != GET_DFP() + 1) {
 	VALUE *new_dfp = GET_CFP()->bp - 1;
 	/* TODO: copy env and clean stack at creating env? */
@@ -1902,7 +1938,7 @@
 	SET_DFP(new_dfp);
     }
 
-#line 1906 "vm.inc"
+#line 1942 "vm.inc"
 #undef CURRENT_INSN_opt_checkenv
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -1915,6 +1951,9 @@
   VALUE recv = TOPN(1);
   VALUE obj = TOPN(0);
   DEBUG_ENTER_INSN("opt_plus");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+1);
   PREFETCH(GET_PC());
   POPN(2);
@@ -1925,7 +1964,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_plus));
   USAGE_ANALYSIS_OPERAND(BIN(opt_plus), 0, ic);
 {
-#line 1336 "insns.def"
+#line 1361 "insns.def"
     if (0) {
 
     }
@@ -1990,7 +2029,7 @@
 	CALL_SIMPLE_METHOD(1, idPLUS, recv);
     }
 
-#line 1994 "vm.inc"
+#line 2033 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_plus
@@ -2005,6 +2044,9 @@
   VALUE recv = TOPN(1);
   VALUE obj = TOPN(0);
   DEBUG_ENTER_INSN("opt_minus");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+1);
   PREFETCH(GET_PC());
   POPN(2);
@@ -2015,7 +2057,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_minus));
   USAGE_ANALYSIS_OPERAND(BIN(opt_minus), 0, ic);
 {
-#line 1412 "insns.def"
+#line 1437 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_MINUS)) {
 	long a, b, c;
@@ -2053,7 +2095,7 @@
 	CALL_SIMPLE_METHOD(1, idMINUS, recv);
     }
 
-#line 2057 "vm.inc"
+#line 2099 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_minus
@@ -2068,6 +2110,9 @@
   VALUE recv = TOPN(1);
   VALUE obj = TOPN(0);
   DEBUG_ENTER_INSN("opt_mult");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+1);
   PREFETCH(GET_PC());
   POPN(2);
@@ -2078,7 +2123,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_mult));
   USAGE_ANALYSIS_OPERAND(BIN(opt_mult), 0, ic);
 {
-#line 1461 "insns.def"
+#line 1486 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_MULT)) {
 	long a, b;
@@ -2121,7 +2166,7 @@
 	CALL_SIMPLE_METHOD(1, idMULT, recv);
     }
 
-#line 2125 "vm.inc"
+#line 2170 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_mult
@@ -2146,7 +2191,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_div));
   USAGE_ANALYSIS_OPERAND(BIN(opt_div), 0, ic);
 {
-#line 1515 "insns.def"
+#line 1540 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_DIV)) {
 	long x, y, div;
@@ -2199,7 +2244,7 @@
 	CALL_SIMPLE_METHOD(1, idDIV, recv);
     }
 
-#line 2203 "vm.inc"
+#line 2248 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_div
@@ -2224,7 +2269,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_mod));
   USAGE_ANALYSIS_OPERAND(BIN(opt_mod), 0, ic);
 {
-#line 1579 "insns.def"
+#line 1604 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_MOD)) {
 	long x, y, mod;
@@ -2276,7 +2321,7 @@
 	CALL_SIMPLE_METHOD(1, idMOD, recv);
     }
 
-#line 2280 "vm.inc"
+#line 2325 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_mod
@@ -2301,7 +2346,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_eq));
   USAGE_ANALYSIS_OPERAND(BIN(opt_eq), 0, ic);
 {
-#line 1642 "insns.def"
+#line 1667 "insns.def"
     val = opt_eq_func(recv, obj, ic);
 
     if (val == Qundef) {
@@ -2311,7 +2356,7 @@
 	CALL_SIMPLE_METHOD(1, idEq, recv);
     }
 
-#line 2315 "vm.inc"
+#line 2360 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_eq
@@ -2338,7 +2383,7 @@
   USAGE_ANALYSIS_OPERAND(BIN(opt_neq), 0, ic);
   USAGE_ANALYSIS_OPERAND(BIN(opt_neq), 1, ic_eq);
 {
-#line 1663 "insns.def"
+#line 1688 "insns.def"
     extern VALUE rb_obj_not_equal(VALUE obj1, VALUE obj2);
     const rb_method_entry_t *me = vm_method_search(idNeq, CLASS_OF(recv), ic);
     val = Qundef;
@@ -2358,7 +2403,7 @@
 	CALL_SIMPLE_METHOD(1, idNeq, recv);
     }
 
-#line 2362 "vm.inc"
+#line 2407 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_neq
@@ -2383,7 +2428,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_lt));
   USAGE_ANALYSIS_OPERAND(BIN(opt_lt), 0, ic);
 {
-#line 1694 "insns.def"
+#line 1719 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_LT)) {
 	SIGNED_VALUE a = recv, b = obj;
@@ -2422,7 +2467,7 @@
 	CALL_SIMPLE_METHOD(1, idLT, recv);
     }
 
-#line 2426 "vm.inc"
+#line 2471 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_lt
@@ -2447,7 +2492,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_le));
   USAGE_ANALYSIS_OPERAND(BIN(opt_le), 0, ic);
 {
-#line 1744 "insns.def"
+#line 1769 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_LE)) {
 	SIGNED_VALUE a = recv, b = obj;
@@ -2466,7 +2511,7 @@
 	CALL_SIMPLE_METHOD(1, idLE, recv);
     }
 
-#line 2470 "vm.inc"
+#line 2515 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_le
@@ -2491,7 +2536,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_gt));
   USAGE_ANALYSIS_OPERAND(BIN(opt_gt), 0, ic);
 {
-#line 1774 "insns.def"
+#line 1799 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_GT)) {
 	SIGNED_VALUE a = recv, b = obj;
@@ -2530,7 +2575,7 @@
 	CALL_SIMPLE_METHOD(1, idGT, recv);
     }
 
-#line 2534 "vm.inc"
+#line 2579 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_gt
@@ -2555,7 +2600,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_ge));
   USAGE_ANALYSIS_OPERAND(BIN(opt_ge), 0, ic);
 {
-#line 1824 "insns.def"
+#line 1849 "insns.def"
     if (FIXNUM_2_P(recv, obj) &&
 	BASIC_OP_UNREDEFINED_P(BOP_GE)) {
 	SIGNED_VALUE a = recv, b = obj;
@@ -2573,7 +2618,7 @@
 	CALL_SIMPLE_METHOD(1, idGE, recv);
     }
 
-#line 2577 "vm.inc"
+#line 2622 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_ge
@@ -2598,7 +2643,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_ltlt));
   USAGE_ANALYSIS_OPERAND(BIN(opt_ltlt), 0, ic);
 {
-#line 1853 "insns.def"
+#line 1878 "insns.def"
     if (!SPECIAL_CONST_P(recv)) {
 	if (0) {
 	}
@@ -2621,7 +2666,7 @@
 	CALL_SIMPLE_METHOD(1, idLTLT, recv);
     }
 
-#line 2625 "vm.inc"
+#line 2670 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_ltlt
@@ -2636,6 +2681,9 @@
   VALUE recv = TOPN(1);
   VALUE obj = TOPN(0);
   DEBUG_ENTER_INSN("opt_aref");
+#if defined(HTM_GVL)
+  RUBY_VM_HTM_CHECK_SCHED(&GET_OPERAND(0));
+#endif
   ADD_PC(1+1);
   PREFETCH(GET_PC());
   POPN(2);
@@ -2646,7 +2694,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_aref));
   USAGE_ANALYSIS_OPERAND(BIN(opt_aref), 0, ic);
 {
-#line 1887 "insns.def"
+#line 1912 "insns.def"
     if (!SPECIAL_CONST_P(recv) && BASIC_OP_UNREDEFINED_P(BOP_AREF)) {
 	if (HEAP_CLASS_OF(recv) == rb_cArray && FIXNUM_P(obj)) {
 	    val = rb_ary_entry(recv, FIX2LONG(obj));
@@ -2665,7 +2713,7 @@
 	CALL_SIMPLE_METHOD(1, idAREF, recv);
     }
 
-#line 2669 "vm.inc"
+#line 2717 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_aref
@@ -2691,7 +2739,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_aset));
   USAGE_ANALYSIS_OPERAND(BIN(opt_aset), 0, ic);
 {
-#line 1917 "insns.def"
+#line 1942 "insns.def"
     if (!SPECIAL_CONST_P(recv) &&
 	BASIC_OP_UNREDEFINED_P(BOP_ASET)) {
 	if (HEAP_CLASS_OF(recv) == rb_cArray && FIXNUM_P(obj)) {
@@ -2714,7 +2762,7 @@
 	CALL_SIMPLE_METHOD(2, idASET, recv);
     }
 
-#line 2718 "vm.inc"
+#line 2766 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_aset
@@ -2738,7 +2786,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_length));
   USAGE_ANALYSIS_OPERAND(BIN(opt_length), 0, ic);
 {
-#line 1951 "insns.def"
+#line 1976 "insns.def"
     if (LIKELY(!SPECIAL_CONST_P(recv) &&
 	       BASIC_OP_UNREDEFINED_P(BOP_LENGTH))) {
 	if (HEAP_CLASS_OF(recv) == rb_cString) {
@@ -2760,7 +2808,7 @@
 	CALL_SIMPLE_METHOD(0, idLength, recv);
     }
 
-#line 2764 "vm.inc"
+#line 2812 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_length
@@ -2784,7 +2832,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_size));
   USAGE_ANALYSIS_OPERAND(BIN(opt_size), 0, ic);
 {
-#line 1984 "insns.def"
+#line 2009 "insns.def"
     if (LIKELY(BASIC_OP_UNREDEFINED_P(BOP_SIZE) &&
 	       !SPECIAL_CONST_P(recv))) {
 	if (HEAP_CLASS_OF(recv) == rb_cString) {
@@ -2806,7 +2854,7 @@
 	CALL_SIMPLE_METHOD(0, idSize, recv);
     }
 
-#line 2810 "vm.inc"
+#line 2858 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_size
@@ -2830,7 +2878,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_succ));
   USAGE_ANALYSIS_OPERAND(BIN(opt_succ), 0, ic);
 {
-#line 2017 "insns.def"
+#line 2042 "insns.def"
     if (SPECIAL_CONST_P(recv)) {
 	if (FIXNUM_P(recv) &&
 	    BASIC_OP_UNREDEFINED_P(BOP_SUCC)) {
@@ -2866,7 +2914,7 @@
 	CALL_SIMPLE_METHOD(0, idSucc, recv);
     }
 
-#line 2870 "vm.inc"
+#line 2918 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_succ
